/**************************************************************************

	nOpen

	main.c

	(C) Copyright 2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <aygshell.h>

#include "stdafx.h"
#include "SelectFile.h"
#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define REG_PATH				TEXT("Software\\tdOpen")

#define BUF_SIZE				256
#define MAX_LOG					10


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE hInst;

static int file_cnt;
static TCHAR file_log[MAX_LOG][BUF_SIZE];

static int cmd_cnt;
static TCHAR cmd_log[MAX_LOG][BUF_SIZE];


/******************************************************************************

	GetOption

	ݒ̓ǂݍ

******************************************************************************/

static void GetOption(void)
{
	HKEY hKey;
	DWORD rc;
	DWORD dwType;
	long len;
	long ret;
	TCHAR buf[BUF_SIZE];
	int i;

	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_PATH, 0, TEXT(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) == ERROR_SUCCESS){
		//t@C
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("file_cnt"), NULL, &dwType, (LPBYTE)&file_cnt, &len);
		for(i = 0; i < file_cnt; i++){
			wsprintf(buf, TEXT("f%d"), i);
			len = sizeof(TCHAR) * BUF_SIZE;
			ret = RegQueryValueEx(hKey, buf, NULL, &dwType, (LPBYTE)&file_log[i], &len);
		}

		//R}hC
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("cmd_cnt"), NULL, &dwType, (LPBYTE)&cmd_cnt, &len);
		for(i = 0; i < cmd_cnt; i++){
			wsprintf(buf, TEXT("c%d"), i);
			len = sizeof(TCHAR) * BUF_SIZE;
			ret = RegQueryValueEx(hKey, buf, NULL, &dwType, (LPBYTE)&cmd_log[i], &len);
		}
		RegCloseKey(hKey);
	}
}


/******************************************************************************

	SetOption

	ݒ̕ۑ

******************************************************************************/

static void SetOption(TCHAR *new_file, TCHAR *new_cmd)
{
	HKEY hKey = 0;
	DWORD rc;
	TCHAR buf[BUF_SIZE];
	int cnt;
	int i;

	RegDeleteKey(HKEY_CURRENT_USER, REG_PATH);

	//WXgɐݒۑ
	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_PATH, 0, TEXT(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) == ERROR_SUCCESS){
		//t@C
		cnt = 0;
		if(*new_file != TEXT('\0')){
			RegSetValueEx(hKey, TEXT("f0"), 0, REG_SZ, (LPBYTE)new_file, sizeof(TCHAR) * (lstrlen(new_file) + 1));
			cnt++;
		}
		for(i = 0; i < file_cnt; i++){
			if(cnt >= MAX_LOG) break;
			if(lstrcmpi(new_file, file_log[i]) != 0 && *(file_log[i]) != TEXT('\0')){
				wsprintf(buf, TEXT("f%d"), cnt);
				RegSetValueEx(hKey, buf, 0, REG_SZ, (LPBYTE)file_log[i], sizeof(TCHAR) * (lstrlen(file_log[i]) + 1));
				cnt++;
			}
		}
		RegSetValueEx(hKey, TEXT("file_cnt"), 0, REG_DWORD, (LPBYTE)&cnt, sizeof(int));

		//R}hC
		cnt = 0;
		if(*new_cmd != TEXT('\0')){
			RegSetValueEx(hKey, TEXT("c0"), 0, REG_SZ, (LPBYTE)new_cmd, sizeof(TCHAR) * (lstrlen(new_cmd) + 1));
			cnt++;
		}
		for(i = 0; i < cmd_cnt; i++){
			if(cnt >= MAX_LOG) break;
			if(lstrcmpi(new_cmd, cmd_log[i]) != 0 && *(cmd_log[i]) != TEXT('\0')){
				wsprintf(buf, TEXT("c%d"), cnt);
				RegSetValueEx(hKey, buf, 0, REG_SZ, (LPBYTE)cmd_log[i], sizeof(TCHAR) * (lstrlen(cmd_log[i]) + 1));
				cnt++;
			}
		}
		RegSetValueEx(hKey, TEXT("cmd_cnt"), 0, REG_DWORD, (LPBYTE)&cnt, sizeof(int));
		RegCloseKey(hKey);
	}
}


/******************************************************************************

	CreateShortcut

	V[gJbg̍쐬

******************************************************************************/

static BOOL CreateShortcut(HWND hWnd, TCHAR *ShortcutFile, TCHAR *file, TCHAR *cmb)
{
	WIN32_FIND_DATA FindData;
	HANDLE hFindFile;
	TCHAR buf[BUF_SIZE];

	if((hFindFile = FindFirstFile(ShortcutFile, &FindData)) != INVALID_HANDLE_VALUE){
		FindClose(hFindFile);

		if(MessageBox(hWnd, TEXT("Do you overwrite?"), TEXT("Overwrite"), MB_ICONQUESTION | MB_YESNO) == IDNO){
			return FALSE;
		}
		DeleteFile(ShortcutFile);
	}
	wsprintf(buf, TEXT("\"%s\" %s"), file, cmb);
	if(SHCreateShortcut(ShortcutFile, buf) == FALSE){
		MessageBox(hWnd, TEXT("Create shortcut failed"), TEXT("Error"), MB_ICONSTOP);
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	ShellOpen

	t@Cs

******************************************************************************/

static BOOL ShellOpen(TCHAR *FileName, TCHAR *CommnadLine)
{
	SHELLEXECUTEINFO sei;

	memset(&sei, 0, sizeof(SHELLEXECUTEINFO));
	sei.cbSize = sizeof(sei);
	sei.fMask = 0;
	sei.hwnd = NULL;
	sei.lpVerb = NULL;
	sei.lpFile = FileName;
	if(*CommnadLine != TEXT('\0')){
		sei.lpParameters = CommnadLine;
	}
	sei.lpDirectory = NULL;
	sei.nShow = SW_SHOWNORMAL;
	sei.hInstApp = hInst;
	return ShellExecuteEx(&sei);
}


/******************************************************************************

	OptionDlgProc

	ݒ

******************************************************************************/

static BOOL CALLBACK MainDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	SIPINFO si;
	TCHAR fname[BUF_SIZE];
	TCHAR cmd[BUF_SIZE];
	TCHAR sname[BUF_SIZE];
	TCHAR buf[BUF_SIZE];
	TCHAR *p, *r;
	RECT rect;
	int i;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		SendMessage(hDlg, WM_SETICON, (WPARAM)FALSE,
			(LPARAM)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON_MAIN), IMAGE_ICON, 16, 16, 0));
		GetWindowRect(hDlg, &rect);
		SetWindowPos(hDlg, 0, 
			GetSystemMetrics(SM_CXSCREEN) / 2 - (rect.right - rect.left) / 2, 
			rect.top + 20,
			0, 0,
			SWP_NOZORDER | SWP_NOSIZE);
		GetOption();
		for(i = 0; i < file_cnt; i++){
			SendDlgItemMessage(hDlg, IDC_COMBO_FILE, CB_ADDSTRING, 0, (LPARAM)file_log[i]);
		}
		for(i = 0; i < cmd_cnt; i++){
			SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDLINE, CB_ADDSTRING, 0, (LPARAM)cmd_log[i]);
		}
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_COMBO_FILE:
		case IDC_COMBO_COMMANDLINE:
			switch(HIWORD(wParam)){
			case CBN_SETFOCUS:
				SHSipPreference(hDlg, SIP_UP);
				break;
			case CBN_KILLFOCUS:
				SHSipPreference(hDlg, SIP_DOWN);
				break;
			}
			break;

		case IDC_BUTTON_FILESELECT:
			if(SelectFile(hDlg, hInst, NULL, buf) == TRUE){
				SendDlgItemMessage(hDlg, IDC_COMBO_FILE, WM_SETTEXT, 0, (LPARAM)buf);
			}
			break;

		case IDC_BUTTON_CMDSELECT:
			if(SelectFile(hDlg, hInst, NULL, buf) == TRUE){
				SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDLINE, WM_SETTEXT, 0, (LPARAM)buf);
			}
			break;

		case IDC_BUTTON_SHORTCUT:
			SendDlgItemMessage(hDlg, IDC_COMBO_FILE, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)fname);
			if(*fname == TEXT('\0')){
				break;
			}
			SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDLINE, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)cmd);

			for(p = r = fname; *p != TEXT('\0'); p++){
				if(*p == TEXT('\\')){
					r = p;
				}
			}
			lstrcpy(buf, r + 1);
			for(p = buf; *p != TEXT('\0') && *p != TEXT('.'); p++);
			*p = TEXT('\0');
			lstrcat(buf, TEXT(".lnk"));

			if(SelectFile(hDlg, hInst, buf, sname) == FALSE){
				break;
			}
			if(CreateShortcut(hDlg, sname, fname, cmd) == FALSE){
				break;
			}
			SetOption(fname, cmd);
			EndDialog(hDlg, FALSE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;

		case IDOK:
			memset(&si, 0, sizeof(si));
			si.cbSize = sizeof(si);
			SHSipInfo(SPI_GETSIPINFO, 0, &si, 0);
			if(si.fdwFlags & SIPF_ON){
				SHSipPreference(hDlg, SIP_DOWN);
				Sleep(1000);
			}
			SendDlgItemMessage(hDlg, IDC_COMBO_FILE, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)fname);
			if(*fname == TEXT('\0')){
				break;
			}
			SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDLINE, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)cmd);
			if(ShellOpen(fname, cmd) == FALSE){
				break;
			}
			SetOption(fname, cmd);
			EndDialog(hDlg, TRUE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	WinMain

	C

******************************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance;

	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL, MainDlgProc, 0);
	return 0;
}
/* End of source */
